-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009, 2010, 2011, 2012 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

--[[
newTalent{
	name = "Exsanguinate",
	type = {"spell/sanguinis", 1},
	require = spells_req1,
	points = 5,
	cooldown = 7,
	mana = 30,
	range = 10,
	proj_speed = 20,
	tactical = { ATTACK = {BLIGHT = 2}, HEAL = 2 },
	requires_target = true,
	target = function(self, t)
		return {type="bolt", range=self:getTalentRange(t), talent=t, display={particle="bolt_blood"}}
	end,
	action = function(self, t)
		local tg = self:getTalentTarget(t)
		local x, y = self:getTarget(tg)
		if not x or not y then return nil end
		self:projectile(tg, x, y, DamageType.DRAINLIFE, {dam=self:spellCrit(self:combatTalentSpellDamage(t, 9, 260)), healfactor= 0.50}, {type="blood"})
		game:playSoundNear(self, "talents/slime")
		return true
	end,
	info = function(self, t)
		return ([[Drain your target of blood doing %0.2f blight damage and healing you for half of the damage done, based on talent level.
		The damage will increase with Magic stat.]):format(damDesc(self, DamageType.BLIGHT, self:combatTalentSpellDamage(t, 9, 260)))
	end,
}]]

newTalent{
	name = "Exsanguinate",
	type = {"spell/sanguinis", 1},
	require = spells_req1,
	points = 5,
	cooldown = 7,
	mana = 30,
	range = 10,
	proj_speed = 20,
	tactical = { ATTACK = {PHYSICAL = 2}, HEAL = 2 },
	requires_target = true,
	target = function(self, t)
		return {type="bolt", range=self:getTalentRange(t), talent=t, display={particle="blood_bolt"}}
	end,
	action = function(self, t)
		local tg = {type="hit", range=self:getTalentRange(t), talent=t}
		local tx, ty, target = self:getTarget(tg)
		if not tx or not ty then return nil end
		local _ _, tx, ty = self:canProject(tg, tx, ty)
		target = game.level.map(tx, ty, Map.ACTOR)
		if not target then return nil end

		local   healpercent = 0.35 + (self:getTalentLevel(t) * 0.05),
		
		target:setEffect(target.EFF_EXSANGUINATE, 3, {src=self, dam=self:combatTalentSpellDamage(t, 10, 120)})
		game:playSoundNear(self, "talents/slime")
		return true
	end,
	info = function(self, t)
		return ([[Drain your target of blood doing %0.2f physical per turn for three turns and healing you for 50%% of the damage done. The damage will increase with Magic stat.]]):format(damDesc(self, DamageType.PHYSDRAIN, self:combatTalentSpellDamage(t, 10, 120)))
	end,
}

--   local healpercent = 0.35 + (self:getTalentLevel(t) * 0.05)
-- 	target:setEffect(target.EFF_EXSANGUINATE, 3, {src=self, dam=self:combatTalentSpellDamage(t, 3, 130)}, healfactor=healpercent)
-- {dam=self:spellCrit(self:combatTalentSpellDamage(t, 3, 130))})

newTalent{
	name = "Blood Sacrifice",
	type = {"spell/sanguinis", 2},
	require = spells_req2,
	points = 5,
	mana = 0,
	cooldown = 30,
	range = 10,
	tactical = { mana = 1 },
	action = function(self, t)
		local amount = self.life * 0.5
		if self.life <= amount + 1 then
			game.logPlayer(self, "Doing this would kill you.")
			return
		end

		local seen = false
		-- Check for visible monsters, only see LOS actors, so telepathy wont prevent resting
		core.fov.calc_circle(self.x, self.y, game.level.map.w, game.level.map.h, 20, function(_, x, y) return game.level.map:opaque(x, y) end, function(_, x, y)
			local actor = game.level.map(x, y, game.level.map.ACTOR)
			if actor and self:reactionToward(actor) < 0 and self:canSee(actor) and game.level.map.seens(x, y) then
				seen = {x=x,y=y,actor=actor}
			end
		end, nil)
		if not seen then
			game.logPlayer(self, "There are no foes in sight.")
			return
		end

		self:takeHit(amount, self)
		self:incMana(50 + self:combatTalentSpellDamage(t, 5, 150))
		game:playSoundNear(self, "talents/slime")
		return true
	end,
	info = function(self, t)
		return ([=[Sacrifices 50%% of your current life to restore %d mana.
		This only works if there is at least one foe in sight.
		The effect will increase with your Magic stat.]=]):
		format(50 + self:combatTalentSpellDamage(t, 5, 150))
	end,
}


--[[
newTalent{
	name = "Blood Exchange old",
	type = {"spell/sanguinis", 2},
	mode = "sustained",
	require = spells_req2,
	points = 5,
	sustain_mana = 10,
	cooldown = 1,
	range = 10,
    no_energy = true,
	tactical = { BUFF = 2 },
	spellpower_increase = { 8, 16, 24, 32, 40 },
	activate = function(self, t)
		game:playSoundNear(self, "talents/spell_generic2")
		if p.souls < 1 then return end
        p.souls = p.souls - 1
		local ret = {
			blood_exchange = self:addTemporaryValue("blood_exchange"),
		}
		return ret
	end,
	deactivate = function(self, t, p)
		self:removeTemporaryValue("blood_exchange")
		return true
	end,
	info = function(self, t)
		return ([[A pact with demonic forces allows you to trade your life for their power, using life to fuel your spells instead of mana. Creating such a connection can be done at will after learned, but requires a soul each time.]):
	end,
} ]]

--[[
newTalent{
	name = "Boiling Blood old",
	type = {"spell/sanguinis", 3},
	require = spells_req3,
	points = 5,
	cooldown = 12,
	mana = 50,
	tactical = { ATTACKAREA = {BLIGHT = 2}, DISABLE = 2 },
	range = 0,
	radius = function(self, t)
		return 2 + self:getTalentLevelRaw(t)
	end,
	requires_target = true,
	target = function(self, t)
		return {type="ball", range=self:getTalentRange(t), radius=self:getTalentRadius(t), selffire=false, talent=t}
	end,
	action = function(self, t)
		local tg = self:getTalentTarget(t)
		local grids = self:project(tg, self.x, self.y, DamageType.BLOOD_BOIL, self:spellCrit(self:combatTalentSpellDamage(t, 28, 190)))
		game.level.map:particleEmitter(self.x, self.y, tg.radius, "ball_blood", {radius=tg.radius})
		game:playSoundNear(self, "talents/slime")
		return true
	end,
	info = function(self, t)
		return (description here) :format(self:getTalentRadius(t), damDesc(self, DamageType.BLIGHT, self:combatTalentSpellDamage(t, 28, 190)))
	end,
}]]

--[[
newTalent{
	name = "Blood is Power old",
	type = {"spell/sanguinis", 3},
	mode = "passive",
	require = spells_req3,
	points = 5,
	info = function(self, t)
		return ([[When you damage one of your foes you sap a bit of their lifeblood to strengthen your spells, increasing your spell power by 1 for each target, up to a maximum of %d per turn.
		The maximum reachable is +%d spell power.
		The bonus decreases by one per turn.]):
		format(math.floor(self:getTalentLevel(t)), math.floor(5 * self:getTalentLevel(t)))
	end,
}]]

newTalent{
	name = "Blood Exchange",
	type = {"spell/sanguinis", 3},
	mode = "sustained",
	require = spells_req3,
	points = 5,
	sustain_mana = 10,
	cooldown = 20,
	range = 10,
    no_energy = false,
	tactical = { BUFF = 2 },
	spellpower_increase = { 16, 32, 48, 64, 80 },  -- for reasons unknown to me the spellpower bonus is halved, so I doubled the base value.
	life_drain = { -2, -4, -6, -8, -10 },
	getSpellpowerIncrease = function(self, t)
	    local v = t.spellpower_increase[self:getTalentLevelRaw(t)]
	    if v then return v else return 20 + (self:getTalentLevelRaw(t) - 5) * 2 end
	end,
	getLifeDrain = function(self, t)
		local w = t.life_drain[self:getTalentLevelRaw(t)]
		if w then return w else return 20 + (self:getTalentLevelRaw(t) - 5) * 2 end
    end,
	activate = function(self, t)
		game:playSoundNear(self, "talents/spell_generic2")
        
		local ret = {
		power = self:addTemporaryValue("combat_spellpower", t.getSpellpowerIncrease(self, t)),
		life_regen = self:addTemporaryValue("life_regen", t.getLifeDrain(self, t)),
		}
		return ret
	end,
	deactivate = function(self, t, p)
		self:removeTemporaryValue("combat_spellpower", p.power)
	    self:removeTemporaryValue("life_regen", p.life_regen)
		return true
	end,
	info = function(self, t)
		local spellpowerinc = t.getSpellpowerIncrease(self, t)
		local liferegenpenalty = t.getLifeDrain(self, t)
		return ([[A pact with demonic forces allows you to trade your life for their power, Increasing spellpower by %d and modifying your life regen by %d.]]):
		format(spellpowerinc * 0.5, liferegenpenalty)
	end,
}

newTalent{
    name = "Blood is Power",
    type = {"spell/sanguinis", 4},
    require = spells_req4,
    points = 5,
    mana = 0,
    cooldown = 25,
    range = 10,
    no_energy = false,
    tactical = { BUFF = 2 },
    action = function(self, t)
        local amount = self.life * 0.5
        self:takeHit(amount, self)
        self:setEffect(self.EFF_POWER_IS_BLOOD, 5, {power=math.ceil(5 + self:getTalentLevel(t) *4)})
        game:playSoundNear(self, "talents/slime")
        return true
    end,
        info = function(self, t)
        return ([[Trade 50%% of your life to an otherworldly being in exchange for even greater power, increasing all your damage by %d%% for 5 turns.]]):
           format(math.ceil(5 + self:getTalentLevel(t) * 4))
    end,
}
