local Stats = require "engine.interface.ActorStats"
local Particles = require "engine.Particles"
local Entity = require "engine.Entity"
local Chat = require "engine.Chat"
local Map = require "engine.Map"
local Level = require "engine.Level"


local _M = loadPrevious(...)

newEffect{
	name = "EXSANGUINATE", image = "effects/exsanguinate.png",
	desc = "Exsanguinate",
	long_desc = function(self, eff) return ("Blood is being drained, doing %0.2f physical damage per turn."):format(eff.power) end,
	type = "magical",
	subtype = { physical=true },
	status = "detrimental",
	parameters = { power=1 },
	on_gain = function(self, err) return "#Target#'s lifeblood begins leaving their body.", "+Exsanguinate" end,
	on_lose = function(self, err) return "#Target#'s lifeblood stops leaving their body.", "-Exsanguinate" end,
	on_timeout = function(self, eff)
		DamageType:get(DamageType.PHYSDRAIN).projector(eff.src, self.x, self.y, DamageType.PHYSDRAIN, eff.dam)
	end,
}

newEffect{
	name = "BLOOD_IS_POWER", image = "talents/blood_is_power.png",
	desc = "Blood is Power",
	long_desc = function(self, eff) return ("The target has traded some of their blood for power, increasing all damage done by %d%%."):format(eff.power) end,
	type = "magical",
	subtype = { darkness=true },
	status = "beneficial",
	parameters = { power=10 },
	on_gain = function(self, err) return "#Target# is overloaded with power.", "+Blood is Power" end,
	on_lose = function(self, err) return "#Target# seems less dangerous.", "-Blood is Power" end,
	activate = function(self, eff)
		eff.pid = self:addTemporaryValue("inc_damage", {all=eff.power})
	end,
	deactivate = function(self, eff)
		self:removeTemporaryValue("inc_damage", eff.pid)
	end,
}
